within Modelica_DeviceDrivers.OperatingSystem;
function clock "the time since OS startup in ms"
  input Integer resolution = 1 "resultion of timer in ms";
  output Real clock "time in ms";

external "C" clock = OS_getTimeMS(resolution);

annotation(Include = "
#ifndef MDDCLOCK
#define MDDCLOCK
#define VOID void
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
typedef unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned int    u_int;
typedef unsigned long   u_long;
typedef unsigned __int64 u_int64;
#include <winsock2.h>//for compatibility reasons 
#include <windows.h> 
#include \"ModelicaUtilities.h\"
#pragma comment( lib, \"Winmm.lib\" ) 
 
double OS_getTimeMS(int resolution)
{
  DWORD ms;
  if(timeBeginPeriod(resolution))
    ModelicaFormatError(\"realtimSynchronize: Resolution not supported by hardware!\");
  ms = timeGetTime();
  timeEndPeriod(resolution);
  return (double)ms;
 
};
 
 
#endif
 
");

end clock;
