#include "SharedMemoryInterface.h"
#include <iostream>
SharedMemoryInterface::SharedMemoryInterface(char * fileName, unsigned int bufSize)
{
	_buffer = NULL;
	_buffer = initSharedMemory(fileName,bufSize);
	if(!_buffer)
	{
		std::cout << "Create or Open a shared memory failed!" << std::endl;
		throw GetLastError();
	}
	else
	{
		memset(_buffer,0,bufSize+sizeof(int));

	}

}
unsigned int SharedMemoryInterface::getDataSize()
{
	int len;
	memcpy(&len,_buffer,sizeof(unsigned int));
	return len;
}
void SharedMemoryInterface::read(char * buffer, unsigned int len)
{
	memcpy(buffer,_buffer + sizeof(unsigned int),len);
}
void SharedMemoryInterface::write(char * buffer, unsigned int len)
{
	memcpy(_buffer + sizeof(unsigned int),buffer,len);
	memcpy(_buffer,&len,sizeof(unsigned int));
}



char * SharedMemoryInterface::initSharedMemory(char * name, unsigned int bufSize)
{
	HANDLE hMapFile;
	char * pBuf;

	hMapFile = CreateFileMappingA(
				 INVALID_HANDLE_VALUE,    // use paging file
				 NULL,                    // default security 
				 PAGE_READWRITE,          // read/write access
				 0,                       // maximum object size (high-order DWORD) 
				 bufSize+sizeof(int),     // maximum object size (low-order DWORD)  
				 name);                 // name of mapping object
	if(GetLastError() == ERROR_ALREADY_EXISTS)
	{
		
		hMapFile = OpenFileMappingA(
                   FILE_MAP_ALL_ACCESS,   // read/write access
                   FALSE,                 // do not inherit the name
                   name);                 // name of mapping object 
		printf("Opening existing FileMapping\n");

	}

	if (hMapFile == NULL) 
	{ 
		printf("Could not create file mapping object (%d).\n", 
			 GetLastError());
		return NULL;
	}
	pBuf = (char * ) MapViewOfFile(hMapFile,   // handle to map object
						FILE_MAP_ALL_ACCESS, // read/write permission
						0,                   
						0,                   
						bufSize+sizeof(int));           

	if (pBuf == NULL) 
	{ 
	  printf("Could not map view of file (%d).\n", 
			 GetLastError()); 

	   CloseHandle(hMapFile);

	  return NULL;
	}
	return pBuf;

}