within Modelica_DeviceDrivers.Utilities;
package Icons "Collection of icons used for library components"
  extends Package;


  partial class Package "Icon for a package class"

    annotation (             Icon(coordinateSystem(
        preserveAspectRatio=false,
        extent={{-100,-100},{100,100}},
        grid={1,1}), graphics={
        Rectangle(
          extent={{-60,100},{100,-60}},
          lineColor={0,0,255},
          fillColor={255,255,255},
          fillPattern=FillPattern.Solid),
        Polygon(
          points={{-100,60},{-60,100},{-60,60},{-100,60}},
          lineColor={0,0,255},
          fillColor={255,255,255},
          fillPattern=FillPattern.Solid),
        Polygon(
          points={{60,-60},{100,-60},{60,-100},{60,-60}},
          lineColor={0,0,255},
          fillColor={255,255,255},
          fillPattern=FillPattern.Solid),
        Rectangle(
          extent={{-100,60},{60,-100}},
          lineColor={0,0,255},
          fillColor={215,215,215},
          fillPattern=FillPattern.Solid)}),
      Documentation(revisions="<html>
<img src=\"../Extras/Images/dlr_logo.png\"  width=60 >
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
 <b>      Copyright &copy; 2006-2007, DLR Institute of Robotics and Mechatronics</b>
</html>", info="<html>
<p>
This partial class is intended to design a <em>default icon for a package class</em>. I should be used for all library packages except for packages of specific purpose (e.g. packages of base classes, of internal material or of examples).
</p>
</html>"));
  end Package;


  annotation (
    preferedView="info",
    classOrder={"Package","BaseClassPackage","VariantPackage","ParametrizedPackage","ExamplesPackage","*"},
    Documentation(
      info="<html>
<p>
A collection of basic icons to be used for different elements of the library.
</p>
<b></b><b></b><b></b><b></b><b></b>
</html>",
      revisions="<html>
<img src=\"../Extras/Images/dlr_logo.png\"  width=60 >
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
 <b>      Copyright &copy; 2006-2007, DLR Institute of Robotics and Mechatronics</b>
</html>"));
end Icons;
